/**********************************************************************
 *
 * IndexXML.java 
 *
 * Copyright 2004 The New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *********************************************************************/
package org.nzdl.gsdl.LuceneWrap;


import java.io.File;

public class IndexXML extends Object {

    String doc_tag_level_ = null;
    File out_dir_         = null;
    Indexer indexer_      = null;
    boolean create_index_ = false;

    public IndexXML(String doc_tag_level, File out_dir, boolean create)
    {
	doc_tag_level_ = doc_tag_level;
	out_dir_ = out_dir;
	create_index_ = create;
    }

    public void init() 
    {
	indexer_ = new Indexer(doc_tag_level_, out_dir_, create_index_);
    }

    public void finish() 
    {
	indexer_.finish();
    }

    public void indexFile(File file) 
    {
	String name = file.getName();
	name = name.substring(0, name.lastIndexOf('.'));
	System.out.println("Indexing "+file.getPath()+" with id "+name);
	indexer_.index(name, file);
    }    

    public void indexFile(String xml_text) 
    {
	indexer_.index(xml_text);
    }    

}
