/**********************************************************************
 *
 * XMLTagInfo.java 
 *
 * Copyright 2006 The New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *********************************************************************/

package org.nzdl.gsdl.LuceneWrap;


import org.xml.sax.Attributes;

/** XMLTagInfo
 * contains any methods that are specific to what kind of XML you are working on
 */

public class XMLTagInfo {

    public static boolean isDocumentLevel(Attributes atts) 
    {
	boolean is_doc_level = false;
	String id = atts.getValue("gs2:id");
	if (id!=null) {
	    is_doc_level = true;
	}
	return is_doc_level;
    }

    public static boolean isIndexable(Attributes atts) 
    {
	boolean is_indexable = false;

	String index = atts.getValue("index");
	if (index!=null) {
	    if (index.equals("1")) {
		is_indexable = true;
	    }
	}
	return is_indexable;
    }

    
}
